// This file is released under the 3-clause BSD license. See COPYING-BSD.
function buildmacros()
  macros_path = get_absolute_file_path("buildmacros.sce");
  tbx_build_macros(TOOLBOX_NAME+"_S_", macros_path);
  lib(macros_path);
  blocks = [
            "ISCOPE"
            "IREP_TEMP"
            "IPARAM_VAR"
            "CEAS_PredefCurrent"
            "CEAS_PredefVoltage"
            "SIMM_POSITIV"
            "RotationalFriction"
            "ExtractPosBar"
            "AnimBar2D"
            ]

  tbx_build_blocks(toolbox_dir, blocks, macros_path);
endfunction

// Load Utils
//getd(get_absolute_file_path("buildmacros.sce")+filesep()+"Utils");

buildmacros();
clear buildmacros; // remove buildmacros on stack

if %f then
    pathB = get_absolute_file_path('buildmacros.sce');
    chdir(pathB);
// directories
    dirs=['Hydraulic'];

    for d = dirs
        if isdir( d ) then
            chdir( d );
            exec('buildmacros.sce');
            chdir( '..' );
        end
    end
    chdir('..');

    clear d dirs pathB
end